# My Favorite Software

This is a collection of software that I like a lot and use on a daily basis.

This page will likely keep growing as I remember more things to add.
Please contact me if you want some other suggestions or if you have suggestions
for me, I welcome it all!

* [Operating Systems](#os)
* [Window Managers](#wm)
* [Text Editors](#editors)
* [Terminal Emulators](#terminals)
* [Web Browsers](#browsers)
* [Mail Clients](#mail)
* [File Managers](#files)
* [Image Viewers](#images)
* [Document Readers](#documents)
* [Music Players](#music)
* [Misc](#misc)
* [To-Do](#todo)

### <a id="os"></a> Operating Systems

I'm a huge fan of BSD and BSD-like operating systems, so I used to support
[ArchLinux](https://archlinux.org).
Then it was switched to systemd and the BSD-like roots were entirely abandoned.
For an Arch-like experience free of systemd, 
check out [Artix Linux](https://artixlinux.org/).

Here is what I actively use now:

* [FreeBSD](https://freebsd.org)

  My absolute favorite operating system and the best choice for a server.
  While, admittedly, not without flaws on the desktop, it combines an 
  amazing system of ports with lots of system customization.

  Useful links if you plan on using FreeBSD:
  * [FreeBSD Handbook](https://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/)
    Should be a good staring point.
  * [Cooltrainer's  guide](https://cooltrainer.org/a-freebsd-desktop-howto/) 
    For FreeBSD on a desktop PC.
  * [Cullum Smith's guide](https://www.c0ffee.net/blog/freebsd-on-a-laptop/) 
    for FreeBSD on a laptop.
  * [Cullun Smith's server guide](https://www.c0ffee.net/blog/freebsd-server-guide/)
    for FreeBSD as a server.

* [Slackware Linux](https://slackware.com)

  One of the OG distributions and the oldest one that is still maintained
  to this day. Very BSD-like and very minimalist in nature, which makes me
  quite happy.

  Unfortunately, unless you are 100% okay with Patrick Volkerding's selection
  of software (a lot of which is pretty good!), you might find some things
  that I mention below missing from the official repos.

  Fortunately, [SlackBuilds](http://slackbuilds.org/) provide an excellent
  way to create your own packages and fuction similar to ArchLinux's Arch
  User Repository ([AUR](https://aur.archlinux.org)).

  Use [sbopkg](https://sbopkg.org/) to easily work with SlackBuilds.

* [Void Linux](https://voidlinux.org/)

  No systemd, has a musl base and its own, pacman-inspired, package manager. 
  Easily the "lightest" OS out of my list in terms of configuration needed,
  so I run it on machines that I didn't want to spend time on configuring.

Honorable mentions:

  * [Gentoo](https://www.gentoo.org/) 

    I am not a big fan of portage and USE-flags for package management,
    so I don't use it, but it's free of systemd and fairly BSD-like.

  * [OpenBSD](https://www.openbsd.org/)

    Has *amazing* support as a desktop *and* a laptop OS. Actively used
    by its developers. Focuses greatly on security. 
    Unfortunately, it lags behind FreeBSD in terms of
    some features. Most notably, OpenBSD is weak in terms of emulation
    and virtualization (no [Wine](https://wine.org), no bhyve), does
    not have a rich system of ports or jails. For those reasons, I do
    not use OpenBSD.

### <a id="wm"></a> Window Managers

* [dwm](https://dwm.suckless.org/)

  My go-to window manager and what I use on *almost* all my machines.
  There is little to say about it. 
  It is [suckless](https://suckless.org/philosophy),
  so it just works.
  
  If you use FreeBSD or OpenBSD, check out
  [sdwmbar](https://github.com/sakhmatd/sdwmbar),
  a simple statusbar that I wrote for dwm.

* [Window Maker](https://www.windowmaker.org/)

  I use Window Maker on machines with touchscreens as DWM is a little tough
  to control touchscreen-only without some serious tweaks.
  Window Maker works great. I really like the NEXTSTEP-like design and
  dockapps, too.

### <a id="editors"></a> Text Editors

* [Vi IMproved](https://www.vim.org/)

  It's vim. You all know it or at least you should.

  vim is quick to start and thus provides a very easy way to edit files 
  straight from the terminal. Lately, I've started using it as a lightweight
  development tool. With vim 8's async support, many of the problems I've
  previously had with vim plugins have disappeared.

  You can find my vim setup with plugins 
  [here](https://git.darkn.space/sakhmatd/dotfiles)

* [Emacs](https://www.gnu.org/software/emacs/),

  Yes, I use both! Even with vim 8's async plugins, I find that Emacs
  still handles larger projects a bit better.

  [This](https://tuhdo.github.io/c-ide.html) article provides a complete set
  of plugins you need to start developing C with Emacs.

  I do not really recommend [Spacemacs](https://spacemacs.org).
  While it seemed like a good idea to me, I found configuration layers to be 
  very hard to troubleshoot when they do not seem to work as intended. 
  Due to abstraction, you need to individually visit every single layer's 
  configuration just to see what is being pulled in. 
  This also means that unless you start with spacemacs-base
  and manually configure every single layer you will be using a 
  whole lot of plugins you never really need,
  slowing down your startup time and using up RAM. 
  And if you were going to go in and set it up manually,
  you may as well as just do that from plain Emacs.

### <a id="terminals"></a> Terminal Emulators

* [st](https://st.suckless.org)

  I use dwm, so this goes hand in hand.
  I suggest you install patches for better mouse support before you use it,
  however.

* [Tilda](https://github.com/lanoxx/tilda)

  What I use on my Window Maker machines. 
  Lightweight and can be pulled in or out with a hotkey.

* [Alacritty](https://github.com/jwilm/alacritty)

  GPU accellerated and fairly simple to configure.
  Not very light in terms of dependencies, however.

* [tmux](https://github.com/tmux/tmux)

  Not exactly a terminal emulator, but rather a terminal multiplexer.
  Somewhat fits in this category, I run it persistently in all of my 
  terminal sessions.

### <a id="browsers"></a> Web Browsers

For the most part, every single browser that supports the horror that is 
the modern web sucks.
[GNU IceCat](https://www.gnu.org/software/icecat/) sucks the least, 
as it is mostly resistant to things like fingerprinting and 
doesn't phone home. It still sucks, however.


* [Dillo](https://www.dillo.org/) 

  Doesn't suck, but also doesn't support JavaScript. 
  If you can live without, it's an amazing choice.

* [Netsurf](http://www.netsurf-browser.org/)

  Lightweight and more user-friendly than Dillo, but
  consumes a *tiny* bit more RAM. Has rudimentary support for
  JavaScript.

* [w3m](http://w3m.sourceforge.net/)

  Best terminal-based web browser from those I've tried. 
  Supports images through image buffers as well as cookies.

## <a id="mail"></a> Mail Clients

* [Neomutt](https://neomutt.org/)

  It's like regular [mutt](https://mutt.org), 
  but with a whole bunch of extra features that make it more usable. 
  Can be interfaced with w3m to view HTML email.

### <a id="files"></a> File Managers

Never really needed one. 
I do most of my file management with coreutils out of the terminal.
However, when I do use one, it's usually
[PCManFM](https://wiki.lxde.org/en/PCManFM) on my
Window Maker machines. 
I've tried [SpaceFM](http://ignorantguru.github.io/spacefm/), but it
wasn't as touchscreen-friendly.

### <a id="images"></a> Image Viewers

* [Mirage](http://mirageiv.sourceforge.net/)

  You'd think it'd be like xev or something, but I really like Mirage.
  It's reasonably lightweight and supports animated images and 
  some obscure raw formats out of the box.

### <a id="documents"></a> Document Readers

* [Zathura](https://pwmt.org/projects/zathura/)

  Best PDF/DjVu viewer out there. Lightweight, has vim-style bindings.

### <a id="music"></a> Music Players 

* [Music on Console](http://moc.daper.net/)

  Does everything I need it to do, supports playlists, has a nice two-pane
  interface and a server-based design.

### <a id="misc"></a> Misc

* [sent](https://tools.suckless.org/sent/)

  Amazing tool for when you need to quickly whip up presenetations.
  Great for presentations in general.

* [ssg](https://www.romanzolotarev.com/ssg.html)

  Quick, no-fuss static website generator. 180 lines of shell code.
  After digging through a whole mess of bloated static site generators,
  this works great for my use-case.

### <a id="todo"></a> To-Do

* Maybe I'll make a similar page for browser addons as well 
  as mobile software that I like.
